#!/usr/bin/env guile
!#

;;; Gacela, a GNU Guile extension for fast games development
;;; Copyright (C) 2017 by Javier Sancho Fernandez <jsf at jsancho dot org>
;;;
;;; This program is free software: you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation, either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

(use-modules (gacela))


(define get-pressed-scene #f)

(set! get-pressed-scene
  (let* ((up (image "up.bmp"))
	 (down (image "down.bmp"))
	 (left (image "left.bmp"))
	 (right (image "right.bmp"))
	 (press (image "press.bmp"))
	 (actived press))
    (lambda ()
      (if (any-key-down?)
	  (cond ((key-down? 'up)
		 (set! actived up))
		((key-down? 'down)
		 (set! actived down))
		((key-down? 'left)
		 (set! actived left))
		((key-down? 'right)
		 (set! actived right))
		(else
		 (set! actived press))))
      actived)))

(display-scene
 (window ((resolution '(640 480)))
   (lambda ()
     (display-scene (get-pressed-scene)))))
